type SubscribedChannel = {
  name: string,
  rules?: string[]
}

const defaultRules: SubscribedChannel['rules'] = [
  'MaxLength', 'MinLength', 'ContainsRTVI', 'ContainsHttp', 'ContainsAd', 'IsRepost', 'HasMedia', 'HasDocument'
]
const config: {subscribedChannels: SubscribedChannel[], targetChannel: string, debugChannel: string} = {
  subscribedChannels: [
    {name: "@banksta", rules: defaultRules.filter(el => el!=='HasMedia')}
  ], 
  targetChannel: "@rus_economy_news",
  debugChannel: "@tiprodbadnews",
};

// Тестовые каналы: @tiprodtest2, "@secretTiprod", "@tiprodbadnews"
// Целевые каналы: rus_economy_news, @rus_economy_news
// Доноры: "@bankrollo", "@rtvimain", "@bbbreaking"


type PromptList = Record<string, {
  command: string
}>

const promptMap: PromptList = {
  newsRetelling: {
      command: 'Переформулируй следующий пост, итоговый пост должен получиться не длиннее 700 символов, расставь двойные абзацы: {post}'
  },
  clearPost: {
      command: 'Убери из текста поста смайлики: {post}'
  },
  scoring: {
    command: `
    Текст поста: 
    """
    {post}
    """

    Представь что ты среднестатистический россиянин по имени - Саша. Вот твой обобщенный портрет: ты мужчина или женщина который живет в столичном городе или городе миллионнике, тебе от 20 до 35 лет, зарабатываешь среднюю по стране зарплату около 60000 руб., у тебя есть жен/муж, один ребенок до 10 лет и кот, есть базовые знания в инвестировании на бирже, брокерский счет и небольшая сумму на вкладе, в отпуск ездишь в Российские курорты и изредка в ближнее зарубежье, у тебя есть поддержанная машина импортного производства, немного следишь за политикой, но без фанатизма.
    
    Контекст происходящего: Россия ведет войну с Украиной с 2022года, многие развитые страны помогаю Украине и накладывают санкции на РФ. В стране усиливается цензура, в том числе и военная.

    Проанализируй пост с точки зрения Саши, учитывая влияние на его жизнь, семью, финансы и обстановку в стране в целом.
    1) В поле 'interestDescribe' напиши почему этот пост может быть интересным/не интересным  для гражданина России.
    2) На сколько пост интересен от -10 до 10 (0  - 'нейтрально', -10 - 'абсолютно не интересно или скучно', 10 - 'очень интересно'), ответ запиши в поле 'interest'.
    3) Если в тексте есть указание на источник, то запиши его в поле source.
    4) Дай оценочное суждение относительно позитивности поста, в поле 'positiveDescribe' напиши почему Саша может расценить пост позитивным или негативным.
    5) Оцени позитивность поста от -10 до 10 (0 - 'нейтрально', -10 - 'абсолютно негативно или агрессивно', 10 - 'очень позитивно'), запиши значение в поле 'positive'.
    6) Попробуй найти субъективное мнение автора, напиши примеры выражения личного мнения автора в поле 'subjectivityDescribe'.     
    7) Найди примеры выражения личного мнения автора в посте если оно есть, определи насколько это эмоционально. На основании проведенного анализа определи как много личного мнения автора в посте от 0 до 10 (0 - 'полое отсутствие мнения автора, только факты', 5 - 'есть немного личного мнения автора, без сильной эмоциональной окраски', 10 - 'пост это мнение автора на какую-то тему'), значение запиши в поле 'subjectivity'.
    8) Подумай чем этот пост может быть важен  для Саши или бесполезен, напиши развернутый ответ в поле 'importantDescribe'. 
    9) На основании 'importantDescribe' определи важность поста для Саши, ответ запиши в поле 'important' (0 - 'не важно', 10 - 'очень важно').
    10) Придумай емкий заголовок для новости длиной не больше 6 слов, запиши его в поле title.
    11) Есть ли в посте есть призыв подписаться на канал, продвижение продуктов определенных организаций или людей или другая реклама, то в поле ads напиши список выгодополучателей и список продуктов которые они продвигают в формате orgname - productname в поле 'adsDescribe'.
    12) Если реклама присутствует то запиши это в поле 'hasAds'
    13) Если в посте есть прямая цитата, то выдели слова и автора цитаты в поле 'quote'.
    14) Придумай емкий заголовок для новости длиной не больше 8 слов отвечающий на вопрос: "Что случилось", запиши его в поле titleTest.
    
    Ответ пришли в формате json с полями -
              interestDescribe: string,
              interest: number,
              title: string,
              source: string,
              positiveDescribe: string,
              positive: number,
              importantDescribe: string,
              important: number,
              subjectivityDescribe: string,
              subjectivity: number,
              adsDescribe: string,
              hasAds: boolean,
              quote: string
              titleTest: string
      `
  },
} as const

export { config, promptMap };

export type {SubscribedChannel}